`timescale 1ns / 1ps

`include "model_1645RU5.v"


module test_1645RU5;		



reg  [7:0] D_IN;
reg [18:0] A;
reg        nWE, nOE, nCE;


wire [7:0] D; 
wire       Dout_nEN;

assign Dout_nEN=~nCE & nWE & ~nOE;
assign D = (Dout_nEN)? 8'bz : D_IN;


model_1645RU5 model_1645RU5_(
D, A, nWE, nOE, nCE
); 



initial
begin  
D_IN<=8'hzz;
nWE<=1'b1;
nOE<=1'b1;
nCE<=1'b1;
A<=18'b0;
nCE_READ (19'h0002);
nCE_READ (19'h1A0C);
nWE_WRITE(19'h0002, 8'h34);
nCE_READ (19'h0002);
test_WRITE_data_change(19'h0002, 8'h34);
test_WRITE_data_change(19'h01A9, 8'hBF);
nCE_READ (19'h0002);
ADR_READ (19'h01A9);
ADR_READ (19'h0002);
ADR_READ (19'h01A9);
nCE_READ (19'h0002);
//test_WRITE_ERROR(19'h0002, 8'h34);

$finish;
end



//-------------------------

task nCE_READ;
input [18:0] adress;  
begin 
#100;
A<=adress;
#100;
nCE<=1'b0;
nOE<=1'b0;
#200; 
nCE<=1'b1;
nOE<=1'b1;
#100;
end
endtask	

task ADR_READ;
input [18:0] adress;  
begin 
nCE<=1'b0;
nOE<=1'b0;
#100;
A<=adress;
#100;
end
endtask	

//-------------------------

task nWE_WRITE;
input [18:0] adress; 
input  [7:0] data; 
begin 
//A<=adress;
//D_IN<=data;
#100;
nCE<=1'b0;
#100;
nWE<=1'b0;
A<=adress;
D_IN<=data;
#40;
nWE<=1'b1;
nCE<=1'b1;
#100; 
D_IN<=8'hzz;
#200; 
end
endtask	

//-------------------------

//-------------------------

task test_WRITE_data_change;
input [18:0] adress; 
input  [7:0] data; 
begin 
//A<=adress;
//D_IN<=data;
#100;
nCE<=1'b0;
#100;
nWE<=1'b0;
A<=adress;
D_IN<=data;
#210;
D_IN<=data+1;
#40;
D_IN<=data+2;
#40;
D_IN<=data+3;
#40;
nWE<=1'b1;
nCE<=1'b1;
#100; 
D_IN<=8'hzz;
#200; 
end
endtask	

//-------------------------

//-------------------------

task test_WRITE_ERROR;
input [18:0] adress; 
input  [7:0] data; 
begin 
//A<=adress;
//D_IN<=data;
#100;
nCE<=1'b0;
#100;
nWE<=1'b0;
A<=adress;
D_IN<=data;
#210;
D_IN<=data+1;
#40;
D_IN<=data+2;
#40;
D_IN<=data+3;
#20;
nWE<=1'b1;
nCE<=1'b1;
#100; 
D_IN<=8'hzz;
#200; 
end
endtask	

//-------------------------

endmodule
